###############################################################################
###############################################################################
##
##  Copyright (C) 2004-2005 Red Hat, Inc.  All rights reserved.
##
##  This copyrighted material is made available to anyone wishing to use,
##  modify, copy, or redistribute it subject to the terms and conditions
##  of the GNU General Public License v.2.
##
###############################################################################
###############################################################################
%define buildup 1
%define buildsmp 1
%define buildxen 0
%define kernel_version 2.6.15-1.1833_FC4
%define subversion 20050601.152643.FC4
 
%ifnarch i686 x86_64
%define buildsmp 0
%endif

%ifnarch i686
%define buildxen 0
%endif

Name: cman-kernel
Version: 2.6.11.5
Release: %{subversion}.23
License: GPL
Group: System Environment/Kernel
Summary: cman-kernel - The Cluster Manager kernel modules
BuildRequires: kernel = %{kernel_version}
BuildRequires: kernel-smp = %{kernel_version}
BuildRequires: kernel-devel = %{kernel_version}
BuildRequires: kernel-smp-devel = %{kernel_version}
Conflicts: GFS <= 6.0
Conflicts: GFS-modules GFS-modules-smp GFS-modules-hugemem
Requires: kernel = %{kernel_version}
Requires: /lib/modules/%{kernel_version}
Provides: kernel-modules
Provides: cman-kernel-modules = %{version}-%{release}
ExclusiveArch: i586 i686 x86_64 ppc ppc64
Source0: %{name}-%{version}-%{subversion}.tar.gz
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
cman-kernel - The Cluster Manager kernel modules

%package -n cman-kernheaders
Group: Development/System
Summary: cman kernel header files

%description -n cman-kernheaders
The cman kernel headers are used by various cluster packages.

%if %{buildsmp}
%package -n cman-kernel-smp
Group: System Environment/Kernel
Summary: cman-kernel-smp - The Cluster Manager kernel smp modules
Requires: kernel-smp = %{kernel_version}
Requires: /lib/modules/%{kernel_version}smp
Provides: kernel-modules
Provides: cman-kernel-modules = %{version}-%{release}
%description -n cman-kernel-smp
cman-kernel-smp - The Cluster Manager kernel smp modules
%endif

%if %{buildxen}
%package -n cman-kernel-xenU
Group: System Environment/Kernel
Summary: cman-kernel-xenU - The Cluster Manager kernel xenU modules
Requires: kernel-xenU = %{kernel_version}
Requires: /lib/modules/%{kernel_version}xenU
Provides: kernel-modules
Provides: cman-kernel-modules = %{version}-%{release}
%description -n cman-kernel-xenU
cman-kernel-xenU - The Cluster Manager kernel xenU modules
%package -n cman-kernel-xen0
Group: System Environment/Kernel
Summary: cman-kernel-xen0 - The Cluster Manager kernel xen0 modules
Requires: kernel-xen0 = %{kernel_version}
Requires: /lib/modules/%{kernel_version}xen0
Provides: kernel-modules
Provides: cman-kernel-modules = %{version}-%{release}
%description -n cman-kernel-xen0
cman-kernel-xen0 - The Cluster Manager kernel xen0 modules
%endif

################################################################################
##  THE PREP SECTION
################################################################################
%prep
%setup -q -n %{name}-%{version}-%{subversion}
# Put the version information into the necessary files
sed  -i -e '/RELEASE_NAME/s/"<CVS>"/"%{version}-%{release}"/' \
      src/cnxman.c 

################################################################################
##  THE BUILD SECTION
################################################################################
%build

BUILD_DIR=`pwd`
cp -r `pwd` ../smp
cp -r `pwd` ../xenU
cp -r `pwd` ../xen0

Build_cman(){
	cpu_type=$1
	flavor=$2
	kernel_src=/lib/modules/%{kernel_version}$flavor/build
	# Kernel tree setup
	if [ -d $kernel_src/. ]; then
		echo $kernel_src
	else
		echo "Kernel %{kernel_version} not found."
		echo $kernel_src
		ls /lib/modules/*
		exit 1
	fi

	./configure --kernel_src=$kernel_src --incdir=%{_includedir}
	if [ "$flavor" == "xenU" -o "$flavor" == "xen0" ]; then
		make ARCH=xen %{?_smp_mflags}
	else
		make %{?_smp_mflags}
	fi
	$kernel_src/scripts/mod/modpost -m -i $kernel_src/Module.symvers src/cman.o -o cman.symvers
}



%if %{buildup}
Build_cman %{_target_cpu}
%endif

%if %{buildsmp}
cd ../smp
Build_cman %{_target_cpu} smp
%endif

%if %{buildxen}
cd ../xenU
Build_cman %{_target_cpu} xenU
cd ../xen0
Build_cman %{_target_cpu} xen0
%endif

################################################################################
##  THE INSTALL SECTION
################################################################################
%install
rm -rf $RPM_BUILD_ROOT

%if %{buildup}
make install DESTDIR=$RPM_BUILD_ROOT
install cman.symvers $RPM_BUILD_ROOT/lib/modules/%{kernel_version}/kernel/cluster/
%endif

%if %{buildsmp}
cd ../smp
make install DESTDIR=$RPM_BUILD_ROOT
install cman.symvers $RPM_BUILD_ROOT/lib/modules/%{kernel_version}smp/kernel/cluster/
%endif

%if %{buildxen}
cd ../xenU
make install DESTDIR=$RPM_BUILD_ROOT ARCH=xen
install cman.symvers $RPM_BUILD_ROOT/lib/modules/%{kernel_version}xenU/kernel/cluster/
cd ../xen0
make install DESTDIR=$RPM_BUILD_ROOT ARCH=xen
install cman.symvers $RPM_BUILD_ROOT/lib/modules/%{kernel_version}xen0/kernel/cluster/
%endif

################################################################################
##  THE CLEAN SECTION
################################################################################
%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/depmod -e %{kernel_version}

%if %{buildsmp}
%post smp
/sbin/depmod -e %{kernel_version}smp
%endif

%if %{buildxen}
%post xenU
/sbin/depmod -e %{kernel_version}xenU
%post xen0
/sbin/depmod -e %{kernel_version}xen0
%endif

%files
%defattr(-,root,root,-)
%dir /lib/modules/%{kernel_version}/kernel/cluster
/lib/modules/%{kernel_version}/kernel/cluster/*

%if %{buildsmp}
%files -n cman-kernel-smp
%defattr(-,root,root,-)
%dir /lib/modules/%{kernel_version}smp/kernel/cluster
/lib/modules/%{kernel_version}smp/kernel/cluster/*
%endif

%if %{buildxen}
%files -n cman-kernel-xenU
%defattr(-,root,root,-)
%dir /lib/modules/%{kernel_version}xenU/kernel/cluster
/lib/modules/%{kernel_version}xenU/kernel/cluster/*
%files -n cman-kernel-xen0
%defattr(-,root,root,-)
%dir /lib/modules/%{kernel_version}xen0/kernel/cluster
/lib/modules/%{kernel_version}xen0/kernel/cluster/*
%endif

%files -n cman-kernheaders
%defattr(-,root,root,-)
%dir %{_includedir}/cluster
%{_includedir}/cluster/*

%changelog
* Mon May 23 2005 Chris Feist <cfeist@redhat.com>
- Fixed depmod in %post scriptlet to use correct kernel.

* Wed May 18 2005 Chris Feist <cfeist@redhat.com>
- Fixed xen building with ARCH=xen & providing cman-kernel-modules.

* Mon May 16 2005 Chris Feist <cfeist@redhat.com>
- Add depmod in %post scriptlet.

* Fri May 06 2005 Chris Feist <cfeist@redhat.com>
- Cleaned up .spec file.

* Fri Apr 29 2005 Chris Feist <cfeist@redhat.com>
- Rebuild for new kernel
- Adding support for i586, xen0 & xenU

* Mon Dec 20 2004 Chris Feist <cfeist@redhat.com>
- Build for new kernel and upstream fixes

* Fri Dec 10 2004 Chris Feist <cfeist@redhat.com>
- Build for new kernel and upstream fixes

* Thu Nov 18 2004 Chris Feist <cfeist@redhat.com>
- various bug fixes (new upstream sources)

* Mon Oct 22 2004 <cfeist@redhat.com>
- Various bug fixes (new upstream sources)

* Mon Aug 16 2004 Jon Brassow <jbrassow@redhat.com>
- New install requirements

* Sat Aug 14 2004 Jon Brassow <jbrassow@redhat.com>
- smp modules were being built, but not packaged
- specify more potential conflicts

* Fri Aug 13 2004 Jon Brassow <jbrassow@redhat.com>
- Various bug fixes (new upstream sources)

* Wed Jul 14 2004 Jon Brassow <jbrassow@redhat.com>
- bump rev # and build for i686 as well

* Mon Jul 13 2004 Jon Brassow <jbrassow@redhat.com> 
- bump rev # and build to proper place

* Mon Jul 13 2004 Jon Brassow <jbrassow@redhat.com> 
- Update for new upstream sources.

* Mon Jul 12 2004 Jon Brassow <jbrassow@redhat.com> 
- Update for new upstream sources.

* Thu Jun 17 2004 Jon Brassow <jbrassow@redhat.com> 
- Initial build.
